/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of FD.xs. Do not edit this file, edit FD.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Linux/FD.xs"
#ifndef _GNU_SOURCE
#	define _GNU_SOURCE
#endif
#define GNU_STRERROR_R

#include <string.h>

#include <sys/eventfd.h>
#include <sys/signalfd.h>
#include <sys/timerfd.h>

#define PERL_NO_GET_CONTEXT
#define PERL_REENTR_API 1
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

#define get_fd(self) PerlIO_fileno(IoOFP(sv_2io(SvRV(self))));

#define die_sys(format) Perl_croak(aTHX_ format, strerror(errno))

static sigset_t* S_sv_to_sigset(pTHX_ SV* sigmask, const char* name) {
	IV tmp;
	if (!SvOK(sigmask))
		return NULL;
	if (!SvROK(sigmask) || !sv_derived_from(sigmask, "POSIX::SigSet"))
		Perl_croak(aTHX_ "%s is not of type POSIX::SigSet");
#if PERL_VERSION > 15 || PERL_VERSION == 15 && PERL_SUBVERSION > 2
	return (sigset_t *) SvPV_nolen(SvRV(sigmask));
#else
	tmp = SvIV((SV*)SvRV(sigmask));
	return INT2PTR(sigset_t*, tmp);
#endif
}
#define sv_to_sigset(sigmask, name) S_sv_to_sigset(aTHX_ sigmask, name)

static sigset_t* S_get_sigset(pTHX_ SV* signal, const char* name) {
	if (SvROK(signal))
		return sv_to_sigset(signal, name);
	else {
		int signo = (SvIOK(signal) || looks_like_number(signal)) && SvIV(signal) ? SvIV(signal) : whichsig(SvPV_nolen(signal));
		SV* buffer = sv_2mortal(newSVpvn("", 0));
		SvGROW(buffer, sizeof(sigset_t));
		sigset_t* ret = (sigset_t*)SvPV_nolen(buffer);
		sigemptyset(ret);
		sigaddset(ret, signo);
		return ret;
	}
}
#define get_sigset(sigmask, name) S_get_sigset(aTHX_ sigmask, name)

#define NANO_SECONDS 1000000000

static NV timespec_to_nv(struct timespec* time) {
	return time->tv_sec + time->tv_nsec / (double)NANO_SECONDS;
}

static void nv_to_timespec(NV input, struct timespec* output) {
	output->tv_sec  = (time_t) floor(input);
	output->tv_nsec = (long) ((input - output->tv_sec) * NANO_SECONDS);
}

typedef struct { const char* key; clockid_t value; } map[];

static map clocks = {
	{ "monotonic", CLOCK_MONOTONIC },
	{ "realtime" , CLOCK_REALTIME  },
};

static clockid_t S_get_clockid(pTHX_ const char* clock_name) {
	int i;
	for (i = 0; i < sizeof clocks / sizeof *clocks; ++i) {
		if (strEQ(clock_name, clocks[i].key))
			return clocks[i].value;
	}
	Perl_croak(aTHX_ "No such timer '%s' known", clock_name);
}
#define get_clockid(name) S_get_clockid(aTHX_ name)

static clockid_t S_get_clock(pTHX_ SV* ref, const char* funcname) {
	SV* value;
	if (!SvROK(ref) || !(value = SvRV(ref)))
		Perl_croak(aTHX_ "Could not %s: this variable is not a clock", funcname);
	return SvIV(value);
}
#define get_clock(ref, func) S_get_clock(aTHX_ ref, func)

static SV* S_io_fdopen(pTHX_ int fd, const char* classname) {
	PerlIO* pio = PerlIO_fdopen(fd, "r");
	GV* gv = newGVgen(classname);
	SV* ret = newRV_noinc((SV*)gv);
	IO* io = GvIOn(gv);
	HV* stash = gv_stashpv(classname, FALSE);
	IoTYPE(io) = '<';
	IoIFP(io) = pio;
	IoOFP(io) = pio;
	sv_bless(ret, stash);
	return ret;
}
#define io_fdopen(fd, classname) S_io_fdopen(aTHX_ fd, classname)

#ifndef EFD_CLOEXEC
#define EFD_CLOEXEC 0
#endif

#ifndef SFD_CLOEXEC
#define SFD_CLOEXEC 0
#endif

#ifndef TFD_CLOEXEC
#define TFD_CLOEXEC 0
#endif

#define SET_HASH_IMPL(key,value) hv_store(hash, key, sizeof key - 1, value, 0)
#define SET_HASH_U(key) SET_HASH_IMPL(#key, newSVuv(buffer.ssi_##key))
#define SET_HASH_I(key) SET_HASH_IMPL(#key, newSViv(buffer.ssi_##key))

static map flags = {
#ifdef EFD_NONBLOCK
	{ "non-blocking", EFD_NONBLOCK },
#endif
#ifdef EFD_SEMAPHORE
	{ "semaphore", EFD_SEMAPHORE },
#endif
};

static UV S_get_event_flag(pTHX_ SV* flag_name) {
	int i;
	for (i = 0; i < sizeof flags / sizeof *flags; ++i)
		if (strEQ(SvPV_nolen(flag_name), flags[i].key))
			return flags[i].value;
	Perl_croak(aTHX_ "No such flag '%s' known", flag_name);
}
#define get_event_flag(name) S_get_event_flag(aTHX_ name)

static SV* S_new_eventfd(pTHX_ const char* classname, UV initial, int flags) {
	int fd = eventfd(initial, flags);
	if (fd < 0)
		die_sys("Can't open eventfd descriptor: %s");
	return io_fdopen(fd, classname);
}
#define new_eventfd(classname, initial, flags) S_new_eventfd(aTHX_ classname, initial, flags)

static SV* S_new_signalfd(pTHX_ const char* classname, SV* sigmask) {
	int fd = signalfd(-1, get_sigset(sigmask, "signalfd"), SFD_CLOEXEC);
	if (fd < 0)
		die_sys("Can't open signalfd descriptor: %s");
	return io_fdopen(fd, classname);
}
#define new_signalfd(classname, sigset) S_new_signalfd(aTHX_ classname, sigset)

static SV* S_new_timerfd(pTHX_ const char* classname, SV* clock, const char* funcname) {
	clockid_t clock_id = SvROK(clock) ? get_clock(clock, funcname) : get_clockid(SvPV_nolen(clock));
	int fd = timerfd_create(clock_id, TFD_CLOEXEC);
	if (fd < 0)
		die_sys("Can't open timerfd descriptor: %s");
	return io_fdopen(fd, classname);
}
#define new_timerfd(classname, clock, func) S_new_timerfd(aTHX_ classname, clock, func)

static int S_interrupted(pTHX_ int value) {
	if (value == -1 && errno == EINTR) {
		PERL_ASYNC_CHECK();
		return 1;
	}
	return 0;
}
#define interrupted(value) S_interrupted(aTHX_ value)

#line 181 "lib/Linux/FD.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 325 "lib/Linux/FD.c"

XS_EUPXS(XS_Linux__FD_eventfd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD_eventfd)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
	UV	initial;
#line 183 "lib/Linux/FD.xs"
		int i, flags = EFD_CLOEXEC;
#line 337 "lib/Linux/FD.c"
	SV *	RETVAL;

	if (items < 1)
	    initial = 0;
	else {
	    initial = (UV)SvUV(ST(0))
;
	}
#line 185 "lib/Linux/FD.xs"
	for (i = 1; i < items; i++)
		flags |= get_event_flag(ST(i));
	RETVAL = new_eventfd("Linux::FD::Event", initial, flags);
#line 350 "lib/Linux/FD.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD_signalfd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD_signalfd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sigmask");
    {
	SV*	sigmask = ST(0)
;
	SV *	RETVAL;
#line 195 "lib/Linux/FD.xs"
	RETVAL = new_signalfd("Linux::FD::Signal", sigmask);
#line 370 "lib/Linux/FD.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD_timerfd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD_timerfd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "clock");
    {
	SV*	clock = ST(0)
;
	SV *	RETVAL;
#line 203 "lib/Linux/FD.xs"
	RETVAL = new_timerfd("Linux::FD::Timer", clock, "timerfd");
#line 390 "lib/Linux/FD.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Event_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Event_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "classname, initial = 0, ...");
    {
	const char*	classname = (const char *)SvPV_nolen(ST(0))
;
	UV	initial;
#line 214 "lib/Linux/FD.xs"
		int i, flags = EFD_CLOEXEC;
#line 410 "lib/Linux/FD.c"
	SV *	RETVAL;

	if (items < 2)
	    initial = 0;
	else {
	    initial = (UV)SvUV(ST(1))
;
	}
#line 216 "lib/Linux/FD.xs"
		for (i = 2; i < items; i++)
			flags |= get_event_flag(ST(i));
		RETVAL = new_eventfd(classname, initial, flags);
#line 423 "lib/Linux/FD.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Event_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Event_get)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV*	self = ST(0)
;
#line 226 "lib/Linux/FD.xs"
		uint64_t buffer;
		int ret, events;
#line 443 "lib/Linux/FD.c"
	UV	RETVAL;
	dXSTARG;
#line 229 "lib/Linux/FD.xs"
		events = get_fd(self);
		do {
			ret = read(events, &buffer, sizeof buffer);
		} while (interrupted(ret));
		if (ret == -1) {
			if (errno == EAGAIN)
				XSRETURN_EMPTY;
			else
				die_sys("Couldn't read from eventfd: %s");
		}
		RETVAL = buffer;
#line 458 "lib/Linux/FD.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Event_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Event_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, value");
    {
	SV*	self = ST(0)
;
	UV	value = (UV)SvUV(ST(1))
;
#line 248 "lib/Linux/FD.xs"
		uint64_t buffer;
		int ret, events;
#line 479 "lib/Linux/FD.c"
	UV	RETVAL;
	dXSTARG;
#line 251 "lib/Linux/FD.xs"
		events = get_fd(self);
		buffer = value;
		do {
			ret = write(events, &buffer, sizeof buffer);
		} while (interrupted(ret));
		if (ret == -1) {
			if (errno == EAGAIN)
				XSRETURN_EMPTY;
			else
				die_sys("Couldn't write to eventfd: %s");
		}
		RETVAL = value;
#line 495 "lib/Linux/FD.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Signal_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Signal_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "classname, sigmask");
    {
	const char*	classname = (const char *)SvPV_nolen(ST(0))
;
	SV*	sigmask = ST(1)
;
#line 274 "lib/Linux/FD.xs"
#line 514 "lib/Linux/FD.c"
	SV *	RETVAL;
#line 275 "lib/Linux/FD.xs"
		RETVAL = new_signalfd(classname, sigmask);
#line 518 "lib/Linux/FD.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Signal_set_mask); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Signal_set_mask)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, sigmask");
    {
	SV*	self = ST(0)
;
	SV*	sigmask = ST(1)
;
#line 283 "lib/Linux/FD.xs"
	int fd;
#line 539 "lib/Linux/FD.c"
#line 285 "lib/Linux/FD.xs"
	fd = get_fd(self);
	if(signalfd(fd, sv_to_sigset(sigmask, "signalfd"), 0) == -1)
		die_sys("Couldn't set_mask: %s");
#line 544 "lib/Linux/FD.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__FD__Signal_receive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Signal_receive)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV*	self = ST(0)
;
#line 293 "lib/Linux/FD.xs"
		struct signalfd_siginfo buffer;
		int tmp, timer;
		HV* hash;
#line 563 "lib/Linux/FD.c"
	SV *	RETVAL;
#line 297 "lib/Linux/FD.xs"
		timer = get_fd(self);
		do {
			tmp = read(timer, &buffer, sizeof buffer);
		} while (interrupted(tmp));
		if (tmp == -1) {
			if (errno == EAGAIN)
				XSRETURN_EMPTY;
			else
				die_sys("Couldn't read from signalfd: %s");
		}
		hash = newHV();
		SET_HASH_U(signo);
		SET_HASH_I(errno);
		SET_HASH_I(code);
		SET_HASH_U(pid);
		SET_HASH_U(uid);
		SET_HASH_I(fd);
		SET_HASH_U(tid);
		SET_HASH_U(band);
		SET_HASH_U(overrun);
		SET_HASH_U(trapno);
		SET_HASH_I(status);
		SET_HASH_I(int);
		SET_HASH_U(ptr);
		SET_HASH_U(utime);
		SET_HASH_U(stime);
		SET_HASH_U(addr);
		RETVAL = newRV_noinc((SV*)hash);
#line 594 "lib/Linux/FD.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Timer_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Timer_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "classname, clock");
    {
	const char*	classname = (const char *)SvPV_nolen(ST(0))
;
	SV*	clock = ST(1)
;
	SV *	RETVAL;
#line 336 "lib/Linux/FD.xs"
		RETVAL = new_timerfd(classname, clock, "Linux::FD::Timer->new");
#line 616 "lib/Linux/FD.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Timer_get_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Timer_get_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0)
;
#line 344 "lib/Linux/FD.xs"
		int timer;
		struct itimerspec value;
#line 638 "lib/Linux/FD.c"
#line 347 "lib/Linux/FD.xs"
		timer = get_fd(self);
		if (timerfd_gettime(timer, &value) == -1)
			die_sys("Couldn't get_timeout: %s");
		mXPUSHn(timespec_to_nv(&value.it_value));
		if (GIMME_V == G_ARRAY)
			mXPUSHn(timespec_to_nv(&value.it_interval));
#line 646 "lib/Linux/FD.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Linux__FD__Timer_set_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Timer_set_timeout)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "self, new_value, new_interval = 0, abstime = 0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0)
;
	NV	new_value = (NV)SvNV(ST(1))
;
	NV	new_interval;
	IV	abstime;
#line 361 "lib/Linux/FD.xs"
		int timer;
		struct itimerspec new_itimer, old_itimer;
#line 671 "lib/Linux/FD.c"
	SV *	RETVAL;

	if (items < 3)
	    new_interval = 0;
	else {
	    new_interval = (NV)SvNV(ST(2))
;
	}

	if (items < 4)
	    abstime = 0;
	else {
	    abstime = (IV)SvIV(ST(3))
;
	}
#line 364 "lib/Linux/FD.xs"
		timer = get_fd(self);
		nv_to_timespec(new_value, &new_itimer.it_value);
		nv_to_timespec(new_interval, &new_itimer.it_interval);
		if (timerfd_settime(timer, (abstime ? TIMER_ABSTIME : 0), &new_itimer, &old_itimer) == -1)
			die_sys("Couldn't set_timeout: %s");
		mXPUSHn(timespec_to_nv(&old_itimer.it_value));
		if (GIMME_V == G_ARRAY)
			mXPUSHn(timespec_to_nv(&old_itimer.it_interval));
#line 696 "lib/Linux/FD.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Linux__FD__Timer_receive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Timer_receive)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV*	self = ST(0)
;
#line 377 "lib/Linux/FD.xs"
		uint64_t buffer;
		int ret, timer;
#line 715 "lib/Linux/FD.c"
	IV	RETVAL;
	dXSTARG;
#line 380 "lib/Linux/FD.xs"
		timer = get_fd(self);
		do {
			ret = read(timer, &buffer, sizeof buffer);
		} while (interrupted(ret));
		if (ret == -1) {
			if (errno == EAGAIN)
				XSRETURN_EMPTY;
			else
				die_sys("Couldn't read from timerfd: %s");
		}
		RETVAL = buffer;
#line 730 "lib/Linux/FD.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Linux__FD); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Linux__FD)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Linux::FD::eventfd", XS_Linux__FD_eventfd);
        newXS_deffile("Linux::FD::signalfd", XS_Linux__FD_signalfd);
        newXS_deffile("Linux::FD::timerfd", XS_Linux__FD_timerfd);
        newXS_deffile("Linux::FD::Event::new", XS_Linux__FD__Event_new);
        newXS_deffile("Linux::FD::Event::get", XS_Linux__FD__Event_get);
        newXS_deffile("Linux::FD::Event::add", XS_Linux__FD__Event_add);
        newXS_deffile("Linux::FD::Signal::new", XS_Linux__FD__Signal_new);
        newXS_deffile("Linux::FD::Signal::set_mask", XS_Linux__FD__Signal_set_mask);
        newXS_deffile("Linux::FD::Signal::receive", XS_Linux__FD__Signal_receive);
        newXS_deffile("Linux::FD::Timer::new", XS_Linux__FD__Timer_new);
        newXS_deffile("Linux::FD::Timer::get_timeout", XS_Linux__FD__Timer_get_timeout);
        newXS_deffile("Linux::FD::Timer::set_timeout", XS_Linux__FD__Timer_set_timeout);
        newXS_deffile("Linux::FD::Timer::receive", XS_Linux__FD__Timer_receive);

    /* Initialisation Section */

#line 174 "lib/Linux/FD.xs"
	load_module(PERL_LOADMOD_NOIMPORT, newSVpvs("IO::Handle"), NULL);
	av_push(get_av("Linux::FD::Event::ISA" , GV_ADD), newSVpvs("IO::Handle"));
	av_push(get_av("Linux::FD::Signal::ISA", GV_ADD), newSVpvs("IO::Handle"));
	av_push(get_av("Linux::FD::Timer::ISA" , GV_ADD), newSVpvs("IO::Handle"));

#line 786 "lib/Linux/FD.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

